(declare (usual-integrations))

;; Instantaneous message delivery

(define (%broadcast cont fuel store message)
  (let ((index (store.index store))
	(sim (store.simulation store)))
    (pp `(broadcast from ,index message ,message))
    (let ((neighbours (vector-ref (simulation.neighbours sim) index)))
      (let ((send-message
	     (simulation.message-interrupt-signaller sim neighbours message)))
	;; Could queue it.  Just send it now.
	(send-message))))
  (cont unspecific (- fuel 1) store))

;; This version currently does not disable interrupts.  Instead, they are
;; nested in lifo order (i.e. the interrupt handler itself can be interrupted
;; arbitrarily many times).

(define (simulation.message-interrupt-signaller sim processors message)
  ;; Use interrupt/1 as a reference/assignment cache
  (if (not (simulation.interrupt/1 sim))
      (set-simulation.interrupt/1! sim (make-cache 'MESSAGE-INTERRUPT-HANDLER)))
  (lambda ()
    (let ((handler-cache (simulation.interrupt/1 sim)))
      (define (setup-interrupt processor-id)
	(and processor-id
	     (let* ((processor (vector-ref (simulation.processors sim) processor-id))
		    (store (processor.store processor)))
	       (let ((handler (global-ref store handler-cache)))
		 (if handler
		     (let ((context (store.saved-context store)))
		       (let ((RTI
			      (lambda (value fuel store)
				value	; ignored
				(global-set! store handler-cache handler)
				(store.restore-context! store context)
				fuel)))
			 (vector-set! store store:context-method resume/1)
			 (vector-set! store store:context/1 handler)
			 (vector-set! store store:context/2 RTI)
			 (vector-set! store store:context/3 message))))))))
      (for-each-vector-element processors setup-interrupt))))
